import os
import sys
import string
import commands
import copy
import Pmw
import Tkinter
from Tkinter import *
import tkMessageBox
from chimera import replyobj
import chimera
import airsIO
import VolumePath.spline
import Midas

import MovieRecorder
from MovieRecorder.RecorderGUI import MovieRecorderGUI

#from chimera import runCommand
#import MovieRecorder.RecorderGUI

def smooth(in_array, kernel=[15,9,3,1]):

	out_array=[0.0]*len(in_array)

	first=copy.copy(kernel)
	first.reverse()
	first=first[0:-1]
	kernel = first + kernel
	norm = sum(kernel)
	hws = len(first) #hws half-window-size


	for i in range(  hws , (len(in_array)-hws ) ):
		sub_array = in_array[i-hws:i+hws+1]
		#print len(kernel)
		#print len(sub_array)
		summ=0

		for j in range(len(kernel)):
			summ=summ + kernel[j]*sub_array[j]

		out_array[i] = summ/norm

	out_array=out_array [hws:len(in_array)-hws]
	return out_array


try:
	import chimera
	from chimera.baseDialog import ModelessDialog
	import VolumeViewer
except:
	print "Chimera not found"
	ModelessDialog=Tkinter.Window
	
class flythru(ModelessDialog):
	name = "flythru ui"
	buttons = ("Close")
	title = "Flythru"
	direman=os.environ["HOME"]
	#hellp = os.path.join(os.environ['EMANDIR'],"doc/AIRS/flythru-help.htm")
	#help = hellp	
	
	def pathSelector(self):
		cmmnames=airsIO.getPDBNames()
		cmmnames.append("None")
		self.inputPathButton.setitems(cmmnames)	
		
	
	def fillInUI(self, parent):
		##setup frames for inputs
		self.frame0=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame0.grid(column=0,row=0, sticky=EW)
		self.frame1=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame1.grid(column=0,row=1, sticky=EW)
		self.frame2=Tkinter.Frame(parent, bd=2, relief=GROOVE)
		self.frame2.grid(column=0,row=2, sticky=EW)
		
		##Make Trajectory Frame
		Label(self.frame1, text='Trajectory').grid(row=0, sticky=EW)
		Label(self.frame2, text='Animation').grid(row=0, sticky=EW)		

		Label(self.frame1, text='Input Path:').grid(row=1, sticky=W)
		self.inputPath=StringVar()
		self.inputPathButton=Pmw.OptionMenu(self.frame1,labelpos=W, menubutton_textvariable=self.inputPath)
		self.inputPathButton.grid(row=1, column=1, sticky=W)
		self.pathSelector()		

		Label(self.frame1, text='Subdivisions:       ').grid(row=2, column=0, sticky=W)
		subdivisions=StringVar()
		self.subdivisions = Entry(self.frame1, textvariable=subdivisions, width = 8)
		subdivisions.set("10")
		self.subdivisions.grid(row=2, column=1, sticky=W)
		
		Label(self.frame1, text='Smoothing Width:').grid(row=3, column=0, sticky=W)
		smoothWidth=StringVar()
		self.smoothWidth = Entry(self.frame1, textvariable=smoothWidth, width = 8)
		smoothWidth.set("7")
		self.smoothWidth.grid(row=3, column=1, sticky=W)

		Button(self.frame1,text='Make Trajectory', command=self.makeTraj).grid(row=4, column=0, sticky=W)



		##Make Animation Frame
		Label(self.frame2, text='Animation').grid(row=0, sticky=EW)
		"""
		vScale=StringVar()
		Label(self.frame2, text='View Scale:       ').grid(row=1, column=0, sticky=W)
		self.vScale = Entry(self.frame2, textvariable=vScale, width = 8)
		vScale.set("0.4")
		self.vScale.grid(row=1, column=1, sticky=W)
		"""
		
		self.reverseTraj=IntVar()
		s = Checkbutton(self.frame2, text="Reverse Trajectory", variable=self.reverseTraj).grid(row=1, column=0, sticky=W)
		
		
		self.showTraj=IntVar()
		s = Checkbutton(self.frame2, text="Hide Trajectory", variable=self.showTraj).grid(row=2, column=0, sticky=W)

		Button(self.frame2,text='Play', command=self.makePlay).grid(row=3, column=0, sticky=W)
		Button(self.frame2,text='Record', command=self.makeRecord).grid(row=3, column=1, sticky=W)
		
	def makeTraj(self):
		inputPathLabel=self.inputPath.get()
		if inputPathLabel=='':
			return
		for model in chimera.openModels.list():
			if model.name==inputPathLabel:
				inputPoints=model

		nAtoms=len(inputPoints.atoms)
		X=[0.0]*nAtoms
		Y=[0.0]*nAtoms
		Z=[0.0]*nAtoms

		index=0
		for atom in inputPoints.atoms:
			X[index] =  atom.coord().x
			Y[index] =  atom.coord().y
			Z[index] =  atom.coord().z
			index=index+1
		#print X; print Y; print Z


		# MAKE TRAJECTORY

		subdivisions =int(self.subdivisions.get())
		Xspline=VolumePath.spline.overhauser_spline_points(X,subdivisions)
		Yspline=VolumePath.spline.overhauser_spline_points(Y,subdivisions)
		Zspline=VolumePath.spline.overhauser_spline_points(Z,subdivisions)

		# SMOOTH TRAJECTORY

		smoothWindowWidth=int(self.smoothWidth.get())
		smoothKernel=[1]* ( 1 + smoothWindowWidth/2 )
		Xspline=smooth(Xspline, smoothKernel)
		Yspline=smooth(Yspline, smoothKernel)
		Zspline=smooth(Zspline, smoothKernel)



		newMol=chimera.Molecule()
		#print type(newMol)
		for attr in ('name','openedAs'):
			if hasattr(inputPoints,attr):
				setattr(newMol, attr, getattr(inputPoints,attr))
		if hasattr(inputPoints,'pdbHeaders'):
			newMol.setAllPDBHeaders(inputPoints.pdbHeaders)
		someOldAtom=inputPoints.atoms[0]



		
		i=0
		while i < len(Xspline):
			nextResidue = newMol.newResidue ('markers', chimera.MolResId('A', i+1))
			#nextAtom = newMol.newAtom(someOldAtom.name, someOldAtom.element)
			nextAtom = newMol.newAtom(str(i), someOldAtom.element)
			nextAtom.setCoord ( chimera.Point (Xspline[i], Yspline[i], Zspline[i] ) )
			nextResidue.addAtom(nextAtom)
			i=i+1
		newMol.name='FlythruTrajectory'
		chimera.openModels.add([newMol])

		self.trajectory=newMol
		Midas.selection.clearCurrent()
		Midas.selection.addCurrent(newMol)
		Midas.represent('sphere')
		Midas.selection.clearCurrent()
		
		recorder=chimera.extension.Manager.findExtensionPackage(chimera.extension.manager, 'MovieRecorder')
		recorder.activate()


	def makePlay(self):
		Midas.selection.clearCurrent()	

		#condition for showing trajectory			
		if int(self.showTraj.get())==1:
			Midas.selection.addCurrent(self.trajectory.atoms)
			Midas.undisplay()
			Midas.selection.clearCurrent()	
		else:
			Midas.selection.addCurrent(self.trajectory.atoms)
			Midas.display()
			Midas.selection.clearCurrent()	

		#condition for reverse trajectory playback
		if int(self.reverseTraj.get())==1:
			increment=-1
			counter=len(self.trajectory.atoms)-1
			prevAtom=self.trajectory.atoms[counter]
			endAtom=self.trajectory.atoms[0]
		else:
			increment=1
			counter=0
			prevAtom=self.trajectory.atoms[counter]
			endAtom=self.trajectory.atoms[-1]			
		#actual flythru
		while prevAtom!= endAtom:
			#Midas.selection.clearCurrent()
			Midas.selection.addCurrent(prevAtom)			
			nextAtom=self.trajectory.atoms[counter+increment]
			#Midas.selection.addCurrent(prevAtom)			
			
			#align
			sel=chimera.selection.ItemizedSelection()
			sel.add(prevAtom)
			sel.add(nextAtom)
			Midas.align(sel)
			Midas.wait(1)			
			
			prevAtom=nextAtom
			counter=counter+increment
			Midas.selection.clearCurrent()
	
	def makeRecord(self):
		# get director
		MovieRecorder.director = MovieRecorder.getDirector()

		# create and show dialog
		mr_exists = chimera.dialogs.find(MovieRecorderGUI.name)
		mr = chimera.dialogs.display(MovieRecorderGUI.name)

		# connect dialog to movie director
		if not mr_exists:
     			mr.synchDirector(MovieRecorder.director)
     			MovieRecorder.director.registerUI(mr)

		# to start/stop
		mr.startRecording()
		self.makePlay()
		mr.stopRecording()


try:
	chimera.dialogs.register(flythru.name, flythru)
except: pass

dialog = None

def gui():
	"""This is a Chimera specfic function to support instantiation of the dialog"""
	global dialog
	if not dialog:
		dialog = flythru()
	dialog.enter()

def Refresh(self, *triggerArgs, **kw):
	if ('model list change' in triggerArgs[-1].reasons) :
		dialog.pathSelector()
triggerOpenModels = chimera.triggers.addHandler('OpenModels', Refresh, None)			
